//Player lokal | Vienna 15.03.2011 Arma2
//
//Fr den EventHandler eine Kamera welche die Geschosse des Spielers verfolgt. 
//
// Das Skript ist ber eine Variable aufzurufen! Variable erstellen:
//	if (isNil "ViennasFiredKamera") then {ViennasFiredKamera = Compile PreprocessFile "Vienna\GeschossCamera\GeschossCam.sqf"};
//
//Aufruf fr Infanterie: player addEventHandler ["Fired", { NearestObject [_this select 0,_this select 4] spawn ViennasFiredKamera}];
//Aufruf fr Fahrzeuge : vehicle player addEventHandler ["Fired", { NearestObject [_this select 0,_this select 4] spawn ViennasFiredKamera}];


private ["_o","_c","_i","_t","_a","_s","_z","_f","_d"];

//globale Variable beim ersten Aufruf fr Kontrolle ob Kamera aktiv
if (isNil "ViennasGeschossKameraAktiv") then 	{ViennasGeschossKameraAktiv = false};

//es darf nur eine Kamerasicht aktiv sein
if (ViennasGeschossKameraAktiv) exitWith{};

ViennasGeschossKameraAktiv = true;

_o =   _this;  //Geschosses-Objekt aus Parameter
_t = time+30;  //Notausstieg nach 30 Sekunden
_s =    0.01;  //Pause nach jeder Kamerasequenz und fr das letzte Bild
_a=      -10;  //Abstand der Kamera zum Verfolgungsobjekt
_z =     0.7;  //Zoom der Kamera auf Weitwinkel
_d =    time;  //Fr Flugzeitberechnung

//Kamera aktivieren
ShowCinemaBorder false;	
_c = "camera" camCreate [0,0,0];
_c cameraEffect ["internal","back"];
_c camSetFOV _z;

//Schleife fr die Geschossverfolgung
_i = true;
while {_i} do
	{
		if (alive _o AND time < _t) then // Geschoss fliegt noch 
			{
				_c camSetTarget _o;
 				_c camSetPos (_o modelToWorld [0,_a,0.07]); //Kameraposition Abstand zum Zielobjekt: [<von der X Position>,<von der Y Position>,<von der Hhe>]
 				_f = vehicle Player distance _o  // Abstand Geschoss zur Waffe
			}
		else   // Geschoss aufgeschlagen oder Zeitablauf
		 	{
		 		if (time < _t) then {_s=1}; // _s Zeit frs "Standbild"
		 		_i=false
		 	};
		_c camCommit 0;
		waitUntil {camCommitted _c};
		sleep _s
	};

//Kamera deaktivieren	
_c cameraEffect ["terminate","back"];
camDestroy _c;

// Fluginfo
Player groupChat format["%1Entfernung: %2 Meter  Flugzeit: %3 Sekunden", if(_s >= 1)then{""}else{"!!! Abbruch !!!   "}, floor _f, (floor(abs((time-_d)*10)))/10];


ViennasGeschossKameraAktiv = false
